#include <GUIConstantsEx.au3>

#cs
	==============================================================================================================

	Name:			Text Effects Designer
	Version:    	1.0 Beta 1
	Author(s):		peethebee (peter_opali@gmx.de)
	AutoIt version:	3.1.1.65 (Beta) or later
	Function:		GUI to chosse, test and generate your effect from my text effects UDF (v1.8 included)
	License:		of course freeware, because the wonderfull AutoIt is freeware too
	Sources:		AutoIt standard funcs and included UDFs
	Download:		peethebee's fileman on "http://www.autoitscript.com/fileman/users/peethebee/"

	===============================================================================================================
#ce


#include <GUIConstants.au3>
#include <Array.au3>
#include <File.au3>
#include "../text_effects.au3"

Global $last_param_given, $out_string

; === Copy "text_effects.au3" into include directory ===
Dim $szdrive, $szdir, $szfname, $szext
_PathSplit (@AutoItExe, $szdrive, $szdir, $szfname, $szext)
$dest = $szdrive & $szdir & "\Include\text_effects.au3"
FileCopy("../text_effects.au3", $dest, 1)


; === Setup funcs and params ===
$funcs = StringSplit(StringReplace("About Messages, Airport, Blink, Broad, Color Sequence, Color to color, Enlarge from left, Enlarge from right, Mix up chars, Move cap char through text, Move small char through text, Move in from left, Move in from right, Move out to left, Move out to right, Move string through text, Raining, Rainbow, Scroll through options, Show text behind char, Small, Spin, Spotlight, Style, Uncover from wall to wall, Wave, Zoom", ", ", ","), ",")
$funcs_internal_name = StringSplit("about_messages,airport,blink,broad,color_sequence,color_to_color,enlarge_from_left,enlarge_from_right,mix_up_chars,move_cap_char_through_text,move_small_char_through_text,move_in_from_left,move_in_from_right,move_out_to_left,move_out_to_right,move_string_through_text,raining,rainbow,scroll_through_options,show_text_behind_char,small,spin,spotlight,style,uncover_from_wall_to_wall,wave,zoom", ",")

Global $func_params[28]
$func_params[1] = '$winhandle;the handle of the target window;the handle of the target window, $control_id;the control ID of the target window;the control ID of the target window, $texts;array containing all texts to show, $delay = 50;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow;time to wait between two animation steps (in ms), $showtime = 2000;time to show a text (in ms) - it is possible to give an array with the values, $pause = 750;time to wait between to texts to show (in ms), $type = "right_to_left":"blink":"enlarge_from_left":"enlarge_from_right":"fade":"left_to_left":"left_to_right":"mix_up":"move_cap_char":"move_small_char":"rainbow":"raining":"right_to_right":"spotlight":"wall_to_wall":"wave":"zoom_big_to_small":"zoom_small_to_big":"modern"'
$func_params[2] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text;text to animate - leave blank to use current controls text, $delay = 50;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow, $start_char = A;char to start to scroll with (ASCII order), $skip_chars = 1;chars to skip in every step'
$func_params[3] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $show_delay = 50;time to show the text, $hide_delay = 50;time to hide the text, $blink_type = all:periodic:parts, $advanced = "";at "all" none - at "periodic" step - at "parts" array containing cutting positions or positions in format "1.4.9", $repetitions = 1;number of repetitions of the effect'
$func_params[4] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $delay = 100;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow, $char = " ";char to insert in order to enlarge text, $go_back = 0:1;smallen afterwards?, $delay_before_go_back = 500;time to wait before smallen the text again'
$func_params[5] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $delay = 50;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow, $colors = "black.green.blue.0xffffff";the colors to fade through. Formattad with "." between values'
$func_params[6] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $duration_per_change = 2000;time between two colors, $colors = "black. white";the colors to fade through. Formattad with "." between values, $precision = 100;internal compution steps'
$func_params[7] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $delay = 100;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow, $over_old = 0:1;Overwrite old text while effect?'
$func_params[8] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $delay = 100;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow, $over_old = 0:1;Overwrite old text while effect?'
$func_params[9] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $delay = 50;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow, $effect_width = 1;width of the effect, $direction = "to_right":"to left";direction of the effect'
$func_params[10] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $delay = 50;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow, $effect_width_chars = 1;width of the effect, $direction = "to_right":"to left";direction of the effect, $convert_to_small = 0:1;Convert the text to small chars before starting the effect?'
$func_params[11] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $delay = 50;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow, $effect_width_chars = 1;width of the effect, $direction = "to_right":"to left";direction of the effect, $convert_to_caps = 0:1;Convert the text to caps before starting the effect?'
$func_params[12] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $delay = 100;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow'
$func_params[13] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $delay = 100;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow, $text_min_width = 0;minimum text width (text is enlarged automatically if it is shorter) - 0> no changes'
$func_params[14] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $delay = 100;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow'
$func_params[15] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $delay = 100;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow, $text_min_width = 0;minimum text width (text is enlarged automatically if it is shorter) - 0> no changes'
$func_params[16] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $delay = 100;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow, $string = "->";string to move through text, $show_complete_text = 0:1;Show complete text the whole time?'
$func_params[17] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $delay = 50;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow, $duration = 3000, $over_old = 0:1;override old text?'
$func_params[18] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $duration_per_change = 2000, $precision = 50;internal computing steps, $direction = 0:1;order of the colors in the rainbow effect'
$func_params[19] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $options;array containing all possible options, $target_text = "";text which shall be the result of the effect, $delay = 50;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow'
$func_params[20] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $delay = 100;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow, $char = "*";char over the text at the beginning'
$func_params[21] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $delay = 100;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow, $char = " ";char which shall be removed'
$func_params[22] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $delay = 100;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow, $num_spins = "1";number of spins, $spin_delay = 0;delay between two spins (in ms)'
$func_params[23] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $delay = 50;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow, $effect_width = 1;width of the effect, $highlighting_start_char = "(";char at the beginning of the highlighting, $highlighting_end_char = ")";char at the end of the highlighting, $display_type = 2:1:0;0 show only effect - 1  show text with effect - 2 show whole text, $direction = "to_right":"to_left";direction of the effect'
$func_params[24] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $type = "bold":"italic":"underline";type of the animation, $font = "Courier New";Font to use for the effect, $remove = 1:0;remove effect after animation?, $show_time = 1500;time to show the effect before undoing it'
$func_params[25] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $delay = 50;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow, $turn_arounds = 1;number of "wall hits"'
$func_params[26] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $delay = 50;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow, $effect_width = 3;width of the effect, $uncover_after_effect = 1:0;uncover the text after effect?, $direction = "to_right":"to_left";direction of the effect'
$func_params[27] = '$winhandle;the handle of the target window, $control_id;the control ID of the target window, $text = "";text to animate - leave blank to use current controls text, $delay = 50;delay between two animation steps (in ms) -> 1 = fast - 1000 - slow, $start_size = 9;text size at the beginning of the effect, $end_size = 2;text size at the end of the effect, $step = 1;step width while down- or upsizing the font size, $font = "Courier New";Font to use, $remove = 0:1;remove text after animation?'


Global $param_input[13], $param_label[13], $param_name[13], $param_is_opt[13]


; === Setup sample arrays for preview ===
Dim $credits[4], $times[4], $start[3], $start_times[3], $options[6], $parts[2]
$credits[0] = "Coder:  p e e t h e b e e ,  2005"
$credits[1] = "Thanks to: J. Bennett and team, the forum members..."
$credits[2] = "and to YOU, if you post your experiences in forum"
$credits[3] = ""
$start[0] = "peethebee Entertainment presents"
$start[1] = "an AutoIt UDF show"
$start[2] = '"T e x t  E f f e c t s   1 . 9"'
$start_times[0] = 1500
$start_times[1] = 1250
$start_times[2] = 2500
$times[0] = 2500
$times[1] = 1500
$times[2] = 1000
$times[3] = 10
$options[0] = "Option 1"
$options[1] = "Option 2"
$options[2] = "Option 3"
$options[3] = "Option 4"
$options[4] = "Option 5"
$options[5] = "Option 6"
$parts[0] = 4
$parts[1] = 10


; === Create GUI ===
$gui = GUICreate("Text Effects Designer 0.95 - by peethebee", 750, 550)


GUICtrlCreateGroup("Preview", 25, 25, 700, 100) ; evenmtually comment out, if the preview does not work properly
$preview_button = GUICtrlCreateButton("Preview on Button", 50, 55, 650)
GUICtrlSetFont(-1, -1, -1, -1, "Courier New")
$preview_input = GUICtrlCreateInput("Preview in Input", 50, 80, 650)
GUICtrlSetFont(-1, -1, -1, -1, "Courier New")


GUICtrlCreateGroup("Select effect", 25, 150, 300, 100)
$funcs_combo_str = ""
For $i = 1 To UBound($funcs) - 1
	$funcs_combo_str = $funcs_combo_str & "|" & $funcs[$i]
Next
$funcs_combo_str = StringTrimLeft($funcs_combo_str, 1)
$funcs_combo = GUICtrlCreateCombo("", 50, 190, 250, 100)
GUICtrlSetData(-1, $funcs_combo_str, $funcs[1])

;prev here

GUICtrlCreateGroup("Define parameters", 350, 150, 375, 340)
; This controls will be created "on the fly"
GUICtrlCreateGroup("", -99, -99, 1, 1)

; temp graphic to fill out the GUI *g*
$image = GUICtrlCreatePic(@ScriptDir & "\pic.jpg", 25, 275, 0, 0)

; buttons
$show_preview_button = GUICtrlCreateButton("&Preview", 335, 510, 140)
$copy_code_button = GUICtrlCreateButton("C&opy code to clipboard", 487, 510, 140)
$close_button = GUICtrlCreateButton("&Close", 637, 510, 90)

GUISetState(@SW_SHOW)

$changed_func = 0

While 1
	$msg = GUIGetMsg()

	Select
		Case $msg = $gui_event_close Or $msg = $close_button
			Exit
		Case $msg = $funcs_combo
			$changed_func = $changed_func + 1
			; generate inputs and labels and tips from parameters of selected func
			; remove old controls and *rescue* the data
			For $i = 1 To 12
				If $changed_func > 1 Then Assign($param_name[$i], GUICtrlRead($param_input[$i]), 0) ; 2: global
			Next

			For $i = 1 To 12
				If $changed_func > 1 Then
					GUICtrlDelete($param_label[$i])
					GUICtrlDelete($param_input[$i])
				EndIf
			Next

			$func_selected = GUICtrlRead($funcs_combo)
			$func_selected_nr = _StringPosInArray($funcs, $func_selected)
			$this_func_params = $func_params[$func_selected_nr]
			$this_func_params = StringReplace($this_func_params, ", ", ",")
			$this_func_params = StringReplace($this_func_params, " ;", ";")
			$this_func_params = StringReplace($this_func_params, "; ", ";")
			$this_func_params = StringReplace($this_func_params, " =", "=")
			$this_func_params = StringReplace($this_func_params, "= ", "=")
			$this_func_params = StringReplace($this_func_params, '"', '')
			$this_func_params_array = StringSplit($this_func_params, ",")


			For $i = 1 To UBound($this_func_params_array) - 1
				$param_is_opt[$i] = "<no>"

				If StringInStr($this_func_params_array[$i], ":") <> 0 Then
					; case 2: param with different possible values
					$param_input[$i] = GUICtrlCreateCombo("", 550, 155 + 25 * $i, 150, 120)
					$parts = StringSplit($this_func_params_array[$i], ":;=")
					$parts[1] = StringTrimLeft($parts[1], 1)
					$param_name[$i] = $parts[1]
					If StringInStr($this_func_params_array[$i], ";") <> 0 Then
						$end = UBound($parts) - 2
						GUICtrlSetTip(-1, $parts[1] & ": " & $parts[UBound($parts) - 1])
					Else
						$end = UBound($parts) - 1
						GUICtrlSetTip(-1, $parts[1])
					EndIf
					If StringInStr($this_func_params_array[$i], "=") <> 0 Then $param_is_opt[$i] = $parts[2]
					$data = "(standard)"
					For $j = 2 To $end
						$data = $data & "|" & $parts[$j]
					Next
					$array = StringSplit($data, "|")
					_ArrayReverse($array)
					_ArrayPop($array)
					_ArraySort($array)
					$data = _ArrayToString($array, "|")
					;ClipPut($string)
					GUICtrlSetData(-1, $data, $parts[2])
					$param_label[$i] = GUICtrlCreateLabel($parts[1] & " (" & $parts[2] & ")", 375, 160 + 25 * $i, 170, 20)

				ElseIf StringInStr($this_func_params_array[$i], "=") <> 0 Then
					; case 1: optional param
					$param_input[$i] = GUICtrlCreateInput("", 550, 155 + 25 * $i, 150, 20)
					$parts = StringSplit($this_func_params_array[$i], "=;")
					$parts[1] = StringTrimLeft($parts[1], 1)
					$param_name[$i] = $parts[1]
					If $parts[0] > 2 Then
						$tip = StringSplit($this_func_params_array[$i], ";")
						GUICtrlSetTip(-1, $parts[1] & ' (optional, standard = "' & $parts[2] & '"): ' & $parts[3])
					Else
						GUICtrlSetTip(-1, $parts[1] & ' (optional, standard = "' & $parts[2] & '")')
					EndIf
					GUICtrlSetData(-1, $parts[2])
					$param_is_opt[$i] = $parts[2]
					$param_label[$i] = GUICtrlCreateLabel($parts[1] & " (" & $parts[2] & ")", 375, 160 + 25 * $i, 170, 20)

				Else
					; last case: required param
					$param_input[$i] = GUICtrlCreateInput("", 550, 155 + 25 * $i, 150, 20)
					$parts = StringSplit($this_func_params_array[$i], ";")
					$parts[1] = StringTrimLeft($parts[1], 1)
					$param_name[$i] = $parts[1]
					If StringInStr($this_func_params_array[$i], ";") <> 0 Then
						GUICtrlSetTip(-1, $parts[1] & ": " & $parts[2])
					Else
						GUICtrlSetTip(-1, $parts[1])
					EndIf
					$param_label[$i] = GUICtrlCreateLabel($parts[1], 375, 160 + 25 * $i, 170, 20)
				EndIf

				If Eval($param_name[$i]) <> "" and ($param_is_opt[$i] = "<no>" Or $param_name[$i] = "text") Then GUICtrlSetData($param_input[$i], Eval($param_name[$i]))
			Next

		Case $msg = $show_preview_button
			If _check_fields(1) = 1 Then
				ContinueLoop
			EndIf

			; generate code
			For $i = 1 To $last_param_given
				$value = GUICtrlRead($param_input[$i])
				If $param_name[$i] = "winhandle" Then $value = "$gui"
				If $param_name[$i] = "control_id" Then $value = "$preview_button"
				If $param_name[$i] = "texts" Then $value = "$credits"
				If $param_name[$i] = "options" Then $value = "$options"
				If (StringIsInt($value) = 0) and (StringIsFloat($value) = 0) Then
					If StringInStr($value, "$") = 0 Then $value = '"' & $value & '"'
				EndIf
				$out_string = $out_string & $value & ", "
			Next

			$out_string = StringTrimRight($out_string, 2)
			$res_string = $out_string & ")"
			ClipPut($res_string)
			$f = GUICtrlRead($funcs_combo)
			Select
				Case $f = "color to color"
					ToolTip("This effect only works with the following components: Label, Checkox, Group, Radio, Edit, Input, Listview, Treeview, Graphic and Progress", 25, 25)
					_txt_eff__color_to_color ($gui, $preview_input, GUICtrlRead($preview_input), GUICtrlRead($param_input[4]), GUICtrlRead($param_input[5]), GUICtrlRead($param_input[6]))
					Sleep(500)
					ToolTip("")
				Case $f = "Color sequence"
					ToolTip("This effect only works with the following components: Label, Checkox, Group, Radio, Edit, Input, Listview, Treeview, Graphic and Progress", 25, 25)
					_txt_eff__color_sequence ($gui, $preview_input, GUICtrlRead($preview_input), GUICtrlRead($param_input[4]), GUICtrlRead($param_input[5]))
					Sleep(500)
					ToolTip("")
				Case $f = "Rainbow"
					ToolTip("This effect only works with the following components: Label, Checkox, Group, Radio, Edit, Input, Listview, Treeview, Graphic and Progress", 25, 25)
					_txt_eff__rainbow ($gui, $preview_input, GUICtrlRead($preview_input), GUICtrlRead($param_input[4]), GUICtrlRead($param_input[5]), GUICtrlRead($param_input[6]))
					Sleep(500)
					ToolTip("")
				Case $f = "Style"
					_txt_eff__style ($gui, $preview_button, GUICtrlRead($preview_button), GUICtrlRead($param_input[4]), GUICtrlRead($param_input[5]), GUICtrlRead($param_input[6]), GUICtrlRead($param_input[7]))
					Sleep(1000)
					_txt_eff__style ($gui, $preview_input, GUICtrlRead($preview_input), GUICtrlRead($param_input[4]), GUICtrlRead($param_input[5]), GUICtrlRead($param_input[6]), GUICtrlRead($param_input[7]))
				Case $f = "Zoom"
					_txt_eff__zoom ($gui, $preview_button, GUICtrlRead($preview_button), GUICtrlRead($param_input[4]), GUICtrlRead($param_input[5]), GUICtrlRead($param_input[6]), GUICtrlRead($param_input[7]), GUICtrlRead($param_input[8]), GUICtrlRead($param_input[9]))
					Sleep(1000)
					_txt_eff__zoom ($gui, $preview_input, GUICtrlRead($preview_input), GUICtrlRead($param_input[4]), GUICtrlRead($param_input[5]), GUICtrlRead($param_input[6]), GUICtrlRead($param_input[7]), GUICtrlRead($param_input[8]), GUICtrlRead($param_input[9]))
				Case Else
					Execute ($res_string)
					$res_string = StringReplace($res_string, "$preview_button", "$preview_input")
					Sleep(1000)
					Execute ($res_string)
			EndSelect

		Case $msg = $copy_code_button
			If _check_fields() = 1 Then
				ContinueLoop
			EndIf

			; generate code
			For $i = 1 To $last_param_given
				$value = GUICtrlRead($param_input[$i])
				If (StringIsInt($value) = 0) and (StringIsFloat($value) = 0) Then
					If StringInStr($value, "$") = 0 Then $value = '"' & $value & '"'
				EndIf
				$out_string = $out_string & $value & ", "
			Next

			$out_string = StringTrimRight($out_string, 2)
			$out_string = $out_string & ")"
			ClipPut($out_string)
			TrayTip("Created the code successfully!", "The necessary code has been copied to clipboard. Insert it by pressing 'ctrl + v' in the right place in your script." & @CRLF & "Don't forget to include the <text_effects.au3> at the start of your script!", 10)
	EndSelect
WEnd




; =================
; === Functions ===
; =================

Func _StringPosInArray($array, $string)
	For $i = 0 To UBound($array) - 1
		If $array[$i] = $string Then Return $i
	Next
EndFunc   ;==>_StringPosInArray

Func _CleanArray($array)
	Return $array
EndFunc   ;==>_CleanArray

Func _check_fields($prev = 0)
	Global $last_param_given, $out_string, $value
	$out_string = "_txt_eff__" & $funcs_internal_name[_StringPosInArray($funcs, $func_selected) ]
	$out_string = $out_string & "("

	; check if required params have been left out
	For $i = 1 To UBound($this_func_params_array) - 1
		If GUICtrlRead($param_input[$i]) = "" And $param_is_opt[$i] = "<no>" Then
			If $prev = 1 Then
				If $param_name[$i] <> "winhandle" And $param_name[$i] <> "control_id" And $param_name[$i] <> "texts" And $param_name[$i] <> "options" Then
					MsgBox(0x10, "Error!", "You left out at least one parameter that is not optional." & @CRLF & "Please fix that!", 2)
					Return 1
				EndIf
			Else
				MsgBox(0x10, "Error!", "You left out at least one parameter that is not optional." & @CRLF & "Please fix that!", 2)
				Return 1
			EndIf
		EndIf
	Next

	; check wich param is filled out the last
	For $i = 1 To UBound($this_func_params_array) - 1
		If GUICtrlRead($param_input[$i]) <> "" And GUICtrlRead($param_input[$i]) <> "(standard)" Then
			If GUICtrlRead($param_input[$i]) <> $param_is_opt[$i] Then
				$last_param_given = $i
			EndIf
		EndIf
		If $prev = 1 Then
			If $param_name[$i] = "winhandle" Or $param_name[$i] = "control_id" Or $param_name[$i] = "texts" Or $param_name[$i] = "options" Then
				If GUICtrlRead($param_input[$i]) <> $param_is_opt[$i] Then
					$last_param_given = $i
				EndIf
			EndIf
		EndIf
	Next

	; fill out missing params in between
	For $i = 1 To $last_param_given
		If GUICtrlRead($param_input[$i]) = "" Or GUICtrlRead($param_input[$i]) = "(standard)" Then
			If (StringIsInt($param_is_opt[$i]) = 1) Or (StringIsFloat($param_is_opt[$i]) = 1) Then
				GUICtrlSetData($param_input[$i], $param_is_opt[$i])
			Else
				GUICtrlSetData($param_input[$i], "")
			EndIf
		EndIf
	Next
	Return 0
EndFunc   ;==>_check_fields

